; SzCpy vs. lstrcpy speed test by Mark Jones (gzscuqn02ATsneakemailD0Tcom)

.586
.model flat, stdcall
option casemap:none

include windows.inc
include kernel32.inc
include masm32.inc
include \masm32\macros\macros.asm
include timers.asm ; library by MichaelW
includelib kernel32.lib
includelib masm32.lib

Main		proto
SzCpy1      proto :DWORD,:DWORD
SzCpy2      proto :DWORD,:DWORD
SzCpy3      proto :DWORD,:DWORD
SzCpy4      proto :DWORD,:DWORD
SzCpy5      proto :DWORD,:DWORD

.data
align 16
String1     DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoP",\
                "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play ",0
align 16
String2     DB  128 dup(0)
LOOP_COUNT  EQU 100000;0        ; 10M iterations per timing result
Szlstrcpy   DB  " lstrcpy              : ",0
SzSzCpy1    DB  " SzCpy1 (movsb/cmp)   : ",0
SzSzCpy2    DB  " SzCpy2 (mov/cmp/inc) : ",0
SzSzCpy3    DB  " SzCpy3 (mov/cmp/add) : ",0
SzSzCpy4    DB  " SzCpy4 (mov/test/inc): ",0
SzSzCpy5    DB  " SzCpy5 (mov/test/add): ",0

.code

Start:
  Invoke Main
  Invoke ExitProcess,0

Main Proc
    print chr$(" SzCpy/lstrcpy speed comparison by Mark Jones (gzscuqn02ATsneakemailD0Tcom)",13,10)
    print chr$(" Timing routines by MichaelW from MASM32 forums, http://www.masmforum.com/",13,10)
;    mov   eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")
    
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    counter_end
    invoke Sleep,250
    print chr$(13,10,13,10," 128-byte string copy timing results:",13,10,13,10)
; -----------------------------------------------    
    print addr Szlstrcpy
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke lstrcpy, addr String2, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10,13,10)
    invoke Sleep,250
; -----------------------------------------------
    print addr SzSzCpy1
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy1, addr String2, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep,250
; -----------------------------------------------    
    print addr SzSzCpy2
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy2, addr String2, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep,250
; -----------------------------------------------    
    print addr SzSzCpy3
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy3, addr String2, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep,250
; -----------------------------------------------    
    print addr SzSzCpy4
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy4, addr String2, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep,250
; -----------------------------------------------    
    print addr SzSzCpy5
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy5, addr String2, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep,250
; -----------------------------------------------    
    mov   eax, input(13,10," Press ENTER to exit...")
    ret
Main EndP


align 16
db 2 dup (0)	; 2 = 537
SzCpy1   proc    SzDest:DWORD, SzSource:DWORD
    mov edi, SzDest         ; load string offsets
    mov esi, SzSource       ; esi = destination!
    cld                     ; clear direction flag
@@:    
    movsb                   ; move a byte, increment edi esi
    cmp byte ptr [esi-1], 0 ; was it a null?
    jnz @B                  ; if no, keep going
	ret
SzCpy1 endp

align 16
db 12 dup (0)	;12 = 480
SzCpy2   proc    SzDest:DWORD, SzSource:DWORD
    mov edi, SzDest         ; edi = destination
    mov esi, SzSource       ; 
@@:    
    mov al, byte ptr [esi]  ; read byte
    mov byte ptr [edi], al  ; write byte
    cmp al,00               ; did we copy a null?
    jz eos                  ; done
    inc esi                 ; else increment pointers using INC
    inc edi
    jmp @B
eos:
	ret
SzCpy2 endp

align 16
db 15 dup (0)	; 15 = 406
SzCpy3   proc    SzDest:DWORD, SzSource:DWORD
    mov edi, SzDest         ; edi = destination
    mov esi, SzSource       ; load string offsets
@@:    
    mov al, byte ptr [esi]  ; read byte
    mov byte ptr [edi], al  ; write byte
    cmp al,00               ; did we copy a null?
    jz eos                  ; done
    add esi,1               ; else increment pointers using ADD
    add edi,1
    jmp @B
eos:
	ret
SzCpy3 endp

align 16
db 8 dup (0)	; 8 = 322
SzCpy4   proc    SzDest:DWORD, SzSource:DWORD
    mov edx, dword ptr SzDest       ; ecx = destination
    mov ecx, dword ptr SzSource     ; load string offsets
@@:    
    mov al, byte ptr [ecx]  ; read byte
    mov byte ptr [edx], al  ; write byte
    inc ecx                 ; incremenr pointers using INC
    inc edx
    test al,al              ; null?
    jnz @B                  ; keep going
    ret
SzCpy4 endp

align 16
db 9 dup (0)  ; 9=343
SzCpy5   proc    SzDest:DWORD, SzSource:DWORD
    mov edx, dword ptr SzDest       ; ecx = destination
    mov ecx, dword ptr SzSource     ; load string offsets
@@:    
    mov al, byte ptr [ecx]  ; read byte
    mov byte ptr [edx], al  ; write byte
    add ecx,1               ; increment pointers using ADD
    add edx,1
    test al,al              ; null?
    jnz @B                  ; keep going
    ret
SzCpy5 endp

End Start
